 Member
_ABCDllMode_  EQUATE(0)
_ABCLinkMode_ EQUATE(1)

 include('SarrayCl.inc')

 Map
   !Local Procedures, if any, go here
   !API Prototypes
   Module('api')
   !clarion cant seem to link getvartype - could make a lib if I need it. wonder if it wasnt avail
   !on 95 or something
      !SafeArrayGetVarType(long psa, *ushort vartype),long,pascal,raw,name('SafeArrayGetVartype')
      SafeArrayGetElemSize(long psa),long,pascal,raw,name('SafeArrayGetElemSize')
      SafeArrayGetDim(long psa),long,pascal,raw,name('SafeArrayGetDim')
      SafeArrayGetLBound(long psa, long ndim, *long LBound),long,pascal,raw
      SafeArrayGetUBound(long psa, long ndim, *long uBound),long,pascal,raw
      SafeArrayGetElement(long psa, long lpArrayOfIndices, long lpvoid),long,pascal,raw,name('SafeArrayGetElement')
      SafeArrayDestroy(long psa),long,pascal,proc,raw,name('SafeArrayDestroy')
      safearraycreate(long VariantType, long cDims, long lpArrofBounds),long,pascal,proc,raw,name('SafeArrayCreate')
      SafeArrayPtrOfIndex(long psa, long lpArrayOfIndices, *long lpdata),long,pascal,proc,raw,name('SafeArrayPtrOfIndex')
      variantinit(long),long,pascal,raw,name('variantinit'),proc
      variantcopy(long,long),long,pascal,raw,name('variantcopy'),proc
      safeArrayAccessData(long,*long),long,pascal,raw,name('SafeArrayAccessData')
      SafeArrayUnAccessData(long),long,pascal,raw,proc,name('SafeArrayUnAccessData')
      memcpy(long,long,long),long,name('_memcpy'),proc
   End
 end


!global data for this module
Return:Benign equate(0)
Return:Fatal  equate(3)
Return:Notify equate(5)

!-------------------------------------------------------------
!---Start of SarrayCl
!-------------------------------------------------------------
SarrayClType.Init                  Procedure(ushort pVariantType, long pDataSize, *long[] arrIndex,long cDims=0)
BoundsArray &String
res         byte(0)
toAddr      long,auto
I           long,auto
dummylong   long(1)
  Code
  !Lbound =1
  clear(SELF)
  if pDatasize<1 then
    SELF.ErrorStr='Data size less than one. Can not create a safearray.'
    return return:fatal
  end
  SELF.DataSize=pDataSize
  if cdims=0 then
    SELF.cdims=maximum(arrIndex,1)
  else
    SELF.cDims=cDims
  end
  if SELF.cDims < 1 then
    SELF.ErrorStr='Bounds less than one. Can not create a Safearray!'
    Return Return:Fatal
  end
  BoundsArray &= new string(SELF.cdims*8)
  if BoundsArray&=NULL then
    SELF.ErrorStr='Out of Memory'
    return return:fatal
  end
  toaddr=address(BoundsArray)
  loop I=1 to SELF.cDims
    memcpy(ToAddr,address(ArrIndex[I]),4 )
    ToAddr+=4
    memcpy(toAddr,address(Dummylong),4)
    ToAddr+=4
  end
  SELF.VariantType=pVariantType
  SELF.psa=SafeArrayCreate(pvarianttype,SELF.cDims, address(BoundsArray))
  If ~SELF.psa then
    SELF.Errorstr='Error creating array.'
    res=Return:Fatal
  end
  dispose(BoundsArray)

  Return  res

SarrayClType.Kill              Procedure()
!destroy any dynamic objects and clean up
hr long,auto
res byte(0)
    Code
    if SELF.psa then
      SELF.UnlockData()
      hr=SafeArrayDestroy(SELF.psa)
      if hr<0 then
        SELF.ErrorStr='Error disposing of SafeArray'
        res=return:notify
      end
      clear(SELF.psa)
    End
    RETURN res

SarrayClType.PutVariant               Procedure(*long[] arrIndex, long pVarType, long pvarData, byte pDeepCopy=0, byte pLeaveLocked=0) !,byte
startofdata long,auto
hr          long,auto
lpdesireddata long,auto
res         byte(0)
Var1  group,auto
vartype    ushort
wreserved1 ushort
wreserved2 ushort
wreserved3 ushort
data1      long
pad        long
  end
Var2  group,auto
vartype    ushort
wreserved1 ushort
wreserved2 ushort
wreserved3 ushort
data1      long
pad        long
  end
res1 byte,auto
  code
  if SELF.VariantType<>12 then return return:fatal. !vt_variant=12
  if SELF.LockData() then return return:fatal.

  hr=SafeArrayPtrOfIndex(SELF.psa, address(arrIndex[]), lpDesiredData)
  if hr<0 then
    SELF.ErrorStr='Can not put data.'
    res=Return:Fatal
  end

  if ~Res then
    if ~pDeepCopy then
      !set up the passed info without any deep copy
      variantinit(address(var1))
      var1.vartype=pvartype
      var1.data1=pVardata
    else
      !put the passed data into var2
      variantinit(address(var2))
      var2.vartype=pvartype
      var2.data1=pVardata
      !deep copy - duplicate any referenced strings or what ever var2 to var1
      variantcopy(Address(Var1),address(var2))
    end
    !copy var1 into the safe array
    memcpy(lpdesireddata,address(var1),Size(Var1))
  end

  if ~pleavelocked then
    res1=SELF.UnlockData()
    if ~res and res1 then res=res1.
  end

  return res



SarrayClType.PutData               Procedure(*long[] arrIndex, long lpData, byte pLeaveLocked=0) !,byte
startofdata long,auto
hr          long,auto
lpdesireddata long,auto
res         byte(0)
res1 byte,auto
  code
  if SELF.LockData() then return return:fatal.

  hr=SafeArrayPtrOfIndex(SELF.psa, address(arrIndex[]), lpDesiredData)
  if hr<0 then
    SELF.ErrorStr='Can not put data.'
    res=Return:Fatal
  end

  if ~Res then
    memcpy(lpDesireddata,lpdata, SELF.DataSize)
  end

  if ~pleavelocked then
    res1=SELF.UnlockData()
    if ~res and res1 then res=res1.
  end

  return res

Sarraycltype.lockdata              procedure()
startofdata long,auto
hr long,auto
  code
  if SELF.DataLocked then return return:benign.
  if ~SELF.psa then
    SELF.ErrorStr='No Safearray defined.'
    return return:fatal
  end
  hr=safeArrayAccessData(SELF.Psa,StartofData)
  if hr<0 then
    SELF.Errorstr='Can not access data.'
    return return:Fatal
  end
  SELF.DataLocked=True
  return return:Benign

SArrayClType.UnlockData             procedure()
hr long,auto
  code
  if ~SELF.Datalocked then return return:benign.
  if ~SELF.psa then
    SELF.ErrorStr='No Safearray defined.'
    return return:fatal
  end
  hr=SafeArrayUnAccessData(SELF.Psa)
  if hr<0 then
    SELF.ErrorStr='Can not unaccess data.'
    return return:Fatal
  end
  clear(SELF.DataLocked)
  return return:benign

SarrayClType.GetData               procedure(*long[] arrIndex, long lpData, byte pLeaveLocked=0) !,byte
hr          long,auto
lpdesireddata long,auto
res         byte(0)
res1 byte,auto
  code
  if SELF.LockData() then return return:fatal.

  hr=SafeArrayPtrOfIndex(SELF.psa, address(arrIndex[]), lpDesiredData)
  if hr<0 then
    SELF.ErrorStr='Bad array indices reading data.'
    res=Return:Fatal
  end

  if ~res then
      memcpy(lpdata,lpdesireddata,SELF.Datasize)
  end

  if ~pleavelocked then
    res1=SELF.UnlockData()
    if ~res and res1 then res=res1.
  end
  return res

SarrayClType.GetDataOne            procedure(*long[] arrIndex, long lpData) !,byte
hr long,auto
  code
  hr=safearraygetelement(self.psa, address(arrindex), lpdata)
  if hr<0 then
    SELF.ErrorStr='Error getting array data.'
    return return:fatal
  end
  return return:Benign

Sarraycltype.Attach     procedure(long psa, ushort pvartype)
hr long,auto
  code
  SELF.VariantType=pVarType
  !hr=SafeArrayGetVarType(psa,SELF.VariantType)
  !if hr<0 then return return:fatal.
  SELF.psa=psa
  SELF.cdims=SafeArrayGetDim(psa)
  if ~SELF.cDims then clear(self);return return:fatal.
  SELF.DataSize=SafeArrayGetElemSize(PSA)
  if ~SELF.DataSize then clear(SELF);Return return:Fatal.
  return return:benign

Sarraycltype.GetDimentionCount procedure()
  code
  return SELF.cDims

Sarraycltype.GetBounds procedure(long pDim, *long lbound, *long ubound)
hr long,auto
  code
  hr=SafeArrayGetLBound(SELF.Psa,pDim,lbound)
  if hr<0 then clear(lbound);clear(ubound);return return:fatal.
  hr=SafeArrayGetUBound(SELF.psa,pdim,ubound)
  if hr<0 then clear(lbound);clear(ubound);return return:fatal.
  return return:benign

sarraycltype.StringToSafeArray  procedure(*long psa, *string buf, long cbBuf)
arrindex long,dim(1)
I        long,auto
res      byte(0)
vt_uI1          equate(11H)
vt_array        equate(2000H)

  code
  clear(psa)
  !Creates a one dimentional byte array.
  arrindex[1]=cbbuf
  if SELF.Init(vt_uI1, 1, arrIndex[],1) then
    !SELF.ErrorStr - set by init
    SELF.kill()
    return 3
  end
  arrIndex[1]=1
  I=0
  loop
    if SELF.PutData(arrIndex[], address(buf)+i, 1) then
      !error string set by putdata
      res=return:fatal
      break
    end
    arrindex[1]+=1
    i+=1
    if I=cbbuf then break.
  end
  if SELF.UnlockData() then
    res=return:fatal
  end
  if res then
    SELF.Kill()
    clear(PSA)
  else
    psa=SELF.Psa
  end
  Return res



sarraycltype.SafeArrayToString  Procedure(long psa, ushort vartype, *byte Res)
!this is ment to be a short cut method for a one step conversion of a safe array from
! from a byte array to a newly allocated string
lbounds         long
ubounds         long
outString       &String
OutStringLen    Long,auto
I               long,auto
byteArrayIndex  long,dim(1)
vt_uI1          equate(11H)
vt_array        equate(2000H)
  code
  OutString &= NULL
  if vartype<>VT_Array + vt_uI1 or ~psa then
    SELF.Errorstr='Not a one dimentional byte array.'
    res=return:fatal
  end
  Clear(SELF.Errorstr)
  if SELF.Attach(psa,VT_UI1) or SELF.GetDimentionCount()<>1 then
    SELF.ErrorStr='Safe array is not a one dimention byte array!'
    Res=Return:Fatal
    return outstring
  end
  if SELF.GetBounds(1,lbounds,ubounds) or ubounds<0 or lbounds<0 then
    SELF.ErrorStr='No Data'
    res=Return:notify
    return outstring
  end
  OutStringLen = Ubounds-Lbounds+1
  outstring &= New string(outstringlen)
  clear(outstring)
  loop I=lbounds to ubounds
    byteArrayIndex[1]=I
    !reads a byte and leaves the data locked
    if SELF.GetData(ByteArrayIndex[],Address(OutString[I-lbounds+1]),1) then
      !SELF.Errorstr is set
      res=return:fatal
      break
    end
  end
  SELF.UnlockData()
  SELF.kill() !frees the safearray
  Return OutString
                                    
sarraycltype.SafeArrayToQ  Procedure(long psa, ushort vartype, Queue DataQ)
!this is ment to be a short cut method for a one step conversion of a safe array from
! from a byte array to a newly allocated string
!NOTE: this method does not call kill and dispose of the safe array - the caller must do that
!  this is done because the array may contain pointers to bstrings and they still need to be read
!  by the caller before disposing of them
lbounds         long
ubounds         long
I               long,auto
ArrayIndex      long,dim(1)
vt_array        equate(2000H)
res             byte(0)
  code
  if vartype<VT_Array  or ~psa then
    SELF.Errorstr='Not a safe array.'
    res=return:fatal
    return res
  end

  Clear(SELF.Errorstr)
  if SELF.Attach(psa,VarType-VT_Array) or SELF.GetDimentionCount()<>1 then
    SELF.ErrorStr='Safe array is not a one dim array!'
    Res=Return:Fatal
    return res
  end

  if Size(DataQ)<SELF.DataSize then
    SELF.ErrorStr='A data element in the array '& SELF.datasize & ' is larger than the output queue size of: '&size(dataq)
    Res=Return:Fatal
    Return res
  end

  if SELF.GetBounds(1,lbounds,ubounds) or ubounds<0 or lbounds<0 then
    SELF.ErrorStr='No Data'
    res=Return:notify
    return res
  end

  loop I=lbounds to ubounds
    ArrayIndex[1]=I
    !reads an element and leaves the data locked
    if SELF.GetData(ArrayIndex[],Address(dataQ),1) then
      !SELF.Errorstr is set
      res=return:fatal
      break
    end
    add(DataQ)
  end
  SELF.UnlockData()
  !DOES NOT free the safearray
  Return res